<template>
  <div v-if="formData" v-loading="loading" class="settings-page">
    <div class="settings-avatar">
      <Avatar :user="user" :size="100" />
      <el-upload where="avatar" type="avatar" class="upload-image" />
    </div>
    <div class="setting-row">
      <div class="col-6">
        <div class="setting-item">
          <div class="setting-item__label">{{ $t('settings.name') }}</div>
          <div class="setting-item__input">
            <el-input
              border
              line
              v-model="formData.display_name"
              :placeholder="$t('settings.name')"
              name="name"
            />
          </div>
        </div>
      </div>
      <div class="col-6">
        <div class="setting-item">
          <div class="setting-item__label">{{ $t('settings.username') }}</div>
          <div class="setting-item__input">
            <el-input
              border
              line
              v-model="formData.username"
              :placeholder="$t('settings.username')"
              name="username"
            />
          </div>
        </div>
      </div>

      <div class="col-6">
        <div class="setting-item">
          <div class="setting-item__label">{{ $t('settings.slogan') }}</div>
          <div class="setting-item__input">
            <el-input
              border
              line
              v-model="formData.slogan"
              :placeholder="$t('settings.slogan')"
              name="slogan"
            />
          </div>
        </div>
      </div>

      <div class="col-6">
        <div class="setting-item">
          <div class="setting-item__label">{{ $t('settings.location') }}</div>
          <div class="setting-item__input" @click="modals.map = true">
            <el-input
              border
              line
              v-model="formData.locations"
              :placeholder="$t('settings.location')"
              readonly=""
            />
          </div>
        </div>
      </div>

      <div class="col-6">
        <div class="setting-item">
          <div class="setting-item__label">I am</div>
          <div
            class="setting-item__input"
            @click="modals.makers = !modals.makers"
          >
            <el-input
              dropdown
              border
              line
              readonly
              value="..."
              :placeholder="$t('settings.styles')"
            >
              <svg-icon name="arrow" class="el-input__icon" slot="suffix" />
            </el-input>
          </div>
        </div>
      </div>

      <div class="col-6" v-if="userStyles">
        <div class="setting-item">
          <div class="setting-item__label">
            {{ $t('settings.styles') }}
          </div>

          <div
            class="setting-item__input"
            @click="modals.styles = !modals.styles"
          >
            <div class="el-input custom-line-select">
              <el-tag
                v-for="item in userStyles.users_styles"
                :key="item.style.id"
                :disable-transitions="false"
                type="success"
              >
                <span>{{ item.style.name }}</span>
              </el-tag>
              <span class="el-input__suffix">
                <svg-icon name="arrow" />
              </span>
            </div>
          </div>
        </div>
      </div>

      <div class="col-12">
        <div class="setting-item">
          <div class="setting-item__label">{{ $t('settings.bio') }}</div>
          <div class="setting-item__input">
            <el-input
              border
              line
              v-model="formData.bio"
              type="textarea"
              :autosize="{ minRows: 1, maxRows: 2 }"
              :placeholder="$t('settings.bio')"
            />
          </div>
        </div>
      </div>

      <div class="col-12" v-if="user">
        <div class="setting-item">
          <div class="setting-item__label">
            Search images
            <span
              v-if="user.media_search_aggregate.aggregate"
              style="color: #8591ad; margin-left: 15px"
            >
              {{ user.media_search_aggregate.aggregate.count }} images
            </span>
          </div>
          <div class="setting-media">
            <div
              class="setting-media__item"
              v-for="item in user.media_search"
              :key="item.id"
            >
              <blur-hash-image
                v-if="item.media_file.blurhash"
                :hash="item.media_file.blurhash"
                :src="`/storage/${item.media_file.preview_url}`"
                class="blurhash"
              />
              <img v-else :src="`/storage/${item.media_file.preview_url}`" />
            </div>
            <div class="add-image" @click="modals.media = !modals.media" v-wave>
              <svg-icon name="plus" />
            </div>
          </div>
        </div>
      </div>

      <!-- <div class="col-6">
        <div class="setting-item">
          <div class="setting-item__label">{{ $t('settings.payment') }}</div>
          <div
            class="setting-item__input"
            @click="modals.payment = !modals.payment"
          >
            <el-input
              border
              line
              :value="getPayment(formData.payment)"
              :placeholder="$t('settings.payment')"
              readonly
            >
              <svg-icon name="arrow" slot="suffix" />
            </el-input>
          </div>
        </div>
      </div> -->

      <div class="col-6" v-if="formData.storage">
        <div class="setting-item">
          <div class="setting-item__label">{{ $t('settings.storage') }}</div>
          <div
            class="setting-item__input"
            @click="modals.storage = !modals.storage"
          >
            <div class="el-input custom-line-select">
              <div>
                {{ formatSizeUnits(formData.storage.available_bytes) }}
              </div>
              <div class="progress">
                <el-progress
                  :text-inside="true"
                  :stroke-width="25"
                  status="success"
                  :percentage="percentage()"
                ></el-progress>
              </div>
              <span class="el-input__suffix">
                <svg-icon name="arrow" />
              </span>
            </div>
          </div>
        </div>
      </div>

      <!-- <div class="col-6">
        <div class="setting-item">
          <div class="setting-item__label">
            {{ $t('settings.statistics') }}
          </div>
          <div class="setting-item__input">
            <el-input
              border
              line
              v-model="form.statistics"
              :placeholder="$t('settings.statistics')"
              disabled
              readonly
            >
              <svg-icon name="arrow" slot="suffix" />
            </el-input>
          </div>
        </div>
      </div> -->

      <!-- <div class="col-6">
        <div class="setting-item">
          <div class="setting-item__label">{{ $t('settings.time') }}</div>
          <div class="setting-item__input">
            <el-input
              border
              line
              v-model="form.time"
              :placeholder="$t('settings.time')"
              disabled
              readonly
            >
              <svg-icon name="arrow" slot="suffix" />
            </el-input>
          </div>
        </div>
      </div> -->

      <!-- <div class="col-6">
        <div class="setting-item">
          <div class="setting-item__label">{{ $t('settings.phone') }}</div>
          <div class="setting-item__input">
            <el-input
              border
              line
              v-model="formData.phone"
              :placeholder="$t('settings.phone')"
            />
          </div>
        </div>
      </div> -->

      <div class="col-6">
        <div class="setting-item">
          <div class="setting-item__label">{{ $t('settings.email') }}</div>
          <div class="setting-item__input">
            <el-input
              border
              line
              v-model="formData.email"
              :placeholder="$t('settings.email')"
            />
          </div>
        </div>
      </div>

      <div class="col-6">
        <Button
          variant="success-opacity"
          size="medium"
          class="btn-space"
          @click="submit"
        >
          {{ $t('settings.update') }}
          <svg-icon name="arrow-line" class="icon-radius" />
        </Button>
      </div>
    </div>

    <Map
      v-if="modals.map"
      :data="newLocationGeo || formData.location"
      type="edit"
      @closeMap="modals.map = false"
      :onCreate="onCreateLocation"
    />

    <MediaSearch
      :show="modals.media"
      @closeSearchMedia="modals.media = false"
    />

    <portal to="modal">
      <Modal v-model="modals.styles">
        <template slot="title">Search style</template>
        <template slot="description">
          Photo styles you work, clients search by them
        </template>
        <template slot="bottom">
          <Button
            variant="success-opacity"
            size="medium"
            @click="modals.styles = false"
          >
            {{ $t('settings.save') }}
            <svg-icon name="arrow-line" class="icon-radius" />
          </Button>
        </template>

        <div class="setting-item">
          <div class="setting-item__label">{{ $t('settings.add') }}</div>
          <div class="setting-item__input">
            <el-input border line v-model="searchStyles" />
          </div>
        </div>

        <div class="setting-item__tags" v-if="userStyles">
          <div
            :key="tagIndex"
            v-for="(tag, tagIndex) in userStyles.users_styles"
          >
            <el-tag
              :disable-transitions="false"
              @close="removeStyleButton(tag)"
              type="success"
              closable
            >
              <span>{{ tag.style.name }}</span>
            </el-tag>
          </div>
        </div>

        <div v-if="globalStyles" class="setting-item__listTags">
          <ul>
            <li
              :key="tagIndex"
              v-for="(tag, tagIndex) in filteredList()"
              @click="addStyleButton(tag)"
            >
              {{ tag.name }}
            </li>
          </ul>
        </div>
      </Modal>
      <Modal v-model="modals.makers">
        <template slot="title">I am</template>
        <template slot="description">...</template>
        <template slot="bottom">
          <Button
            variant="success-opacity"
            size="medium"
            @click="modals.makers = false"
          >
            {{ $t('settings.save') }}
            <svg-icon name="arrow-line" class="icon-radius" />
          </Button>
        </template>
        <el-checkbox-group v-model="formData.payment">
          <div>
            <el-checkbox label="Photographer">Photographer</el-checkbox>
          </div>
          <div>
            <el-checkbox label="Artist">Artist</el-checkbox>
          </div>
          <div>
            <el-checkbox label="Dancer">Dancer</el-checkbox>
          </div>
          <div>
            <el-checkbox label="Etc">Etc</el-checkbox>
          </div>
        </el-checkbox-group>
      </Modal>
      <Modal v-model="modals.payment">
        <template slot="title">{{ $t('settings.payment') }}</template>
        <template slot="description">Types of payment you work with </template>
        <template slot="bottom">
          <Button
            variant="success-opacity"
            size="medium"
            @click="modals.payment = false"
          >
            {{ $t('settings.save') }}
            <svg-icon name="arrow-line" class="icon-radius" />
          </Button>
        </template>
        <el-checkbox-group v-model="formData.payment">
          <div>
            <el-checkbox label="PER_FILE">
              {{ $t('payment_type.per_file') }}
            </el-checkbox>
          </div>
          <div>
            <el-checkbox label="FIXED">
              {{ $t('payment_type.fixed') }}
            </el-checkbox>
          </div>
          <div>
            <el-checkbox label="DONATION">
              {{ $t('payment_type.donation') }}
            </el-checkbox>
          </div>
        </el-checkbox-group>
      </Modal>
      <Modal v-model="modals.storage">
        <template slot="title">{{ $t('settings.storage') }}</template>
        <template slot="description">
          {{ $t('settings.subscription') }}
        </template>
        <template slot="bottom">
          <Button
            variant="success-opacity"
            size="medium"
            @click="modals.storage = false"
          >
            {{ $t('settings.save') }}
            <svg-icon name="arrow-line" class="icon-radius" />
          </Button>
        </template>
        <div>
          <el-radio v-model="form.storage" label="3 GB">3 GB – free</el-radio>
        </div>
      </Modal>
      <Modal v-model="modals.statistics">
        <template slot="title">{{ $t('settings.statistics') }}</template>
        <template slot="description">
          Downloads, visits in albums and events
        </template>
        <template slot="bottom">
          <Button
            variant="success-opacity"
            size="medium"
            @click="modals.statistics = false"
          >
            {{ $t('settings.save') }}
            <svg-icon name="arrow-line" class="icon-radius" />
          </Button>
        </template>
        <div>
          <el-radio v-model="form.statistics" label="24 hours"
            >24 hours</el-radio
          >
        </div>
        <div>
          <el-radio v-model="form.statistics" label="Weekly">Weekly</el-radio>
        </div>
        <div>
          <el-radio v-model="form.statistics" label="Monthly">Monthly</el-radio>
        </div>
      </Modal>
      <Modal v-model="modals.time">
        <template slot="title">{{ $t('settings.time') }}</template>
        <template slot="description">
          Time when you upload images after session
        </template>
        <template slot="bottom">
          <Button
            variant="success-opacity"
            size="medium"
            @click="modals.time = false"
          >
            {{ $t('settings.save') }}
            <svg-icon name="arrow-line" class="icon-radius" />
          </Button>
        </template>
        <div>
          <el-radio v-model="form.time" label="24 hours">24 hours</el-radio>
        </div>
        <div>
          <el-radio v-model="form.time" label="1 week">1 week</el-radio>
        </div>
        <div>
          <el-radio v-model="form.time" label="Month">Month</el-radio>
        </div>
      </Modal>
    </portal>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  useContext,
  ref,
  reactive,
  computed
} from '@nuxtjs/composition-api'

import {
  useGetUserStyleQuery,
  useUpdateCurrentUserMutation,
  useCreateLocationMutation,
  useGetStyleQuery
} from '~/sdk/hooks'
import { CurrentUserFragment } from '@/sdk/types'
import useTranslate from '~/hooks/get-translate'

import elCheckbox from '@/components/element/Checkbox.vue'
import elCheckboxGroup from '@/components/element/CheckboxGroup.vue'
import elInput from '@/components/element/Input.vue'
import elRadio from '@/components/element/Radio.vue'
import elTag from '@/components/element/Tag.vue'
import elUpload from '@/components/element/Upload.vue'

import Avatar from '@/components/ui/Avatar.vue'
import Button from '@/components/ui/Button.vue'
import Modal from '@/components/ui/Modal.vue'
import Map from '@/components/ui/Map.vue'
import Feed from '@/components/ui/Feed.vue'

import MediaSearch from '@/components/modal/MediaSearch.vue'

import { omit, pick } from 'lodash'

export default defineComponent({
  name: 'SettingPage',
  components: {
    Avatar,
    Modal,
    Map,
    Button,
    elInput,
    elRadio,
    elCheckboxGroup,
    elCheckbox,
    elUpload,
    elTag,
    Feed,
    MediaSearch
  },
  setup(_, { root }) {
    const user = computed(() => root.$accessor.auth.user)
    const { app } = useContext()
    if (!user.value) return

    const formData = reactive<
      Pick<
        CurrentUserFragment,
        | 'id'
        | 'username'
        | 'display_name'
        | 'slogan'
        | 'bio'
        | 'phone'
        | 'location_id'
      > & {
        location: any
        locations: any
        email: string
        styles: string[]
        payment: string[]
        storage: any
      }
    >({
      id: user.value.id,
      username: user.value.username,
      display_name: user.value.display_name,
      slogan: user.value.slogan,
      bio: user.value.bio,
      location: user.value?.location,
      locations: user.value.location
        ? [user.value.location.city, user.value.location.country]
            .filter(e => !!e)
            .join(', ')
        : null,
      location_id: user.value.location_id,
      phone: user.value.phone,
      email: user.value.account?.email,
      styles: user.value.styles.map(r => r.style_id),
      payment: user.value.payment_types.map(r => r.payment_type),
      storage: user.value.storage
    })

    const modals = ref({
      styles: false,
      storage: false,
      payment: false,
      statistics: false,
      time: false,
      makers: false,
      map: false,
      media: false
    })

    // percentage

    const percentage = () => {
      let percentage =
        (100 * formData.storage.used_bytes) / formData.storage.available_bytes
      return Number(percentage.toFixed(2))
    }

    // map component

    const newLocation = ref()
    const newLocationGeo = ref(null)
    const onCreateLocation = (data: any) => {
      modals.value.map = false
      formData.locations = data.location_name
      newLocation.value = data
      newLocationGeo.value = data.coordinates
    }

    const form = reactive({
      payment: ['Free'],
      storage: '3 GB',
      statistics: '24 hours',
      time: '24 hours'
    })

    // payment
    const getPayment = (item: Array<String>) => {
      let result = item.toString() as String
      result =
        item.length > 1
          ? item.length + ' options'
          : (useTranslate(result) as any)
      return result
    }

    // styles block

    const { result: globalStyles } = useGetStyleQuery()
    const { result: userStyles } = useGetUserStyleQuery({
      userId: user.value.id
    })
    const searchStyles = ref('')
    const filteredList = () => {
      if (searchStyles.value !== '') {
        return globalStyles.value.styles.filter(item => {
          return item.name
            .toLowerCase()
            .startsWith(searchStyles.value.toLowerCase())
        })
      } else {
        return globalStyles.value.styles
      }
    }
    const addStyleButton = (item: any) => {
      if (!formData.styles) return
      if (!formData.styles.includes(item.id)) {
        const styleData = {
          style_id: item.id,
          style: {
            id: item.id,
            name: item.name
          }
        }
        formData.styles.push(item.id)
        userStyles.value.users_styles.push(styleData as any)
        searchStyles.value = ''
      }
    }
    const removeStyleButton = (tag: any) => {
      formData.styles.splice(formData.styles.indexOf(tag.style.id), 1)
      userStyles.value.users_styles.splice(userStyles.value.users_styles.indexOf(tag),1)
    }
    const formatSizeUnits = (bytes: any) => {
      if (bytes >= 1073741824) {
        bytes = (bytes / 1073741824).toFixed(0) + ' GB'
      } else if (bytes >= 1048576) {
        bytes = (bytes / 1048576).toFixed(0) + ' MB'
      } else if (bytes >= 1024) {
        bytes = (bytes / 1024).toFixed(0) + ' KB'
      } else if (bytes > 1) {
        bytes = bytes + ' bytes'
      } else if (bytes == 1) {
        bytes = bytes + ' byte'
      } else {
        bytes = '0 bytes'
      }
      return bytes
    }

    const { mutate, loading, onDone } = useUpdateCurrentUserMutation({})
    const { mutate: updateGeo } = useCreateLocationMutation({})
    const submit = async () => {
      if (!user.value) return
      const userId = user.value.id as string
      try {
        if (newLocation.value) {
          await updateGeo({
            object: {
              id: newLocation.value.id,
              ...newLocation.value.geo,
              geo: {
                type: 'Point',
                coordinates: newLocation.value.coordinates
              }
            }
          })
        }
        await mutate({
          userId: userId,
          user: {
            ...pick(formData, [
              'username',
              'display_name',
              'slogan',
              'bio',
              'phone'
            ]),
            location_id:
              newLocation.value?.id || user.value?.location_id || undefined
          },
          email: formData.email,
          styles: formData.styles.map(r => ({
            style_id: r
          }))
          // payment: formData.payment.map(
          //   r =>
          //     ({
          //       payment_type: r
          //     } as any)
          // )
        })
      } catch {
        root.$message.success('erorr')
      } finally {
        root.$message.success('Profile updated successfully')
      }
    }

    return {
      user,
      loading,
      form,
      modals,
      formData,

      submit,
      onCreateLocation,
      newLocation,
      newLocationGeo,

      getPayment,
      globalStyles,
      userStyles,

      searchStyles,
      filteredList,
      addStyleButton,
      removeStyleButton,

      formatSizeUnits,

      percentage,
      useTranslate
    }
  }
})
</script>

<style lang="scss" scoped>
.setting-row {
  display: grid;
  grid-template-columns: repeat(12, 1fr);
  grid-row-gap: 30px;

  .col-6 {
    grid-column: span 12;
  }
  .col-12 {
    grid-column: span 12;
  }

  @media (min-width: 1199.98px) {
    grid-column-gap: 85px;
    grid-row-gap: 45px;
    max-width: 75%;

    .col-6 {
      grid-column: span 6;
    }
    .col-12 {
      grid-column: span 12;
    }
  }
}

.settings-avatar {
  margin-bottom: 30px;
  display: flex;
  align-items: center;
  @media (min-width: 768px) {
    margin-bottom: 50px;
  }
  .upload-image {
    flex: none;
    margin-left: 15px;
  }
}

.setting-media {
  display: flex;
  align-items: center;
  flex-wrap: wrap;
  margin-top: 30px;
  margin-bottom: -5px;
  margin-right: -5px;
  @media (min-width: 768px) {
    margin-bottom: -12px;
    margin-right: -12px;
  }
  > * {
    flex: none;
    width: calc(33.3333% - 5px);
    height: 70px;
    margin-right: 5px;
    margin-bottom: 5px;
    @media (min-width: 768px) {
      margin-right: 12px;
      margin-bottom: 12px;
      width: 125px;
      height: 90px;
    }
  }
  &__item {
    border-radius: 2px;
    overflow: hidden;
    ::v-deep {
      .blurhash {
        padding-bottom: 0px !important;
        height: 100%;
        span {
          position: relative !important;
          display: block;
        }
      }
    }
  }
  & .add-image {
    background: #22283a;
    border-radius: 2px;
    overflow: hidden;
    display: flex;
    align-items: center;
    justify-content: center;
    svg {
      width: 20px;
      height: 20px;
      fill: #00ffb3;
    }
  }
}

.setting-item {
  &__label {
    font-size: 24px;
    line-height: 30px;
    font-weight: 500;
    color: #00ffb3;
    margin-bottom: -5px;
  }
  &__tags {
    display: flex;
    flex-wrap: wrap;
    margin-top: 25px;
    margin-bottom: 25px;
    > * {
      flex: none;
      padding-right: 15px;
      padding-bottom: 10px;
    }
  }
  &__listTags {
    ul {
      margin: 0;
      padding: 0;
      list-style: none;
      display: flex;
      flex-wrap: wrap;
      align-items: center;
      li {
        flex: none;
        padding-right: 30px;
        padding-bottom: 15px;
        color: #fff;
        font-size: 24px;
        line-height: 30px;
        transition: 0.25s all linear;
        cursor: pointer;

        &:hover {
          color: #00ffb3;
        }
      }
    }
  }
}
</style>
